//: # Foundation in Swift 3

import Foundation

/*:
 `NS` prefix 'dropped'
*/


//: ## Value semantics

var now = Date()
var anotherNow = now

anotherNow = Date(timeIntervalSinceNow: -3600)
now


/*:
 
 - `Date`
 - `Data`
 - `URL`
 - `IndexPath`
 - etc...
 */


//: ## Nested enumerations
let formatter = NumberFormatter()
formatter.numberStyle = .currency
formatter.string(for: 123.32)


//: ## Extends to strings
NSNotification.Name.NSSystemTimeZoneDidChange

extension Notification.Name {
  static let MyMagicNotification = Notification.Name("com.razeware.MyMagicNotification")
}

Notification.Name.MyMagicNotification

//: ## Class properties

Calendar.current

//: ## Character / Index Sets `SetAlgebra` protocol

let vowels = CharacterSet(charactersIn: "aeiou")
let myName = "samuel"
let vowelsInMyName = CharacterSet(charactersIn: myName).intersection(vowels)


//: ## DateComponents
let fridayMorning = DateComponents(weekday: 6, weekOfMonth: 1, weekOfYear: 1)


//: ## Data has a collection API
let ascii = "Hello ascii String"
let data = ascii.data(using: .ascii, allowLossyConversion: true)!

for byte in data {
  print(byte)
  print(String(bytes: [byte], encoding: .ascii))
}

data[5]

